project "BarinkEngine"
  kind "StaticLib"

  buildmessage "Building BarinkEngine"

  includedirs {
    "Include/",

    "../libs/lua/include",
    "../libs/spdlog/include",
    "../libs/glm",
    "../libs/GorillaAudio/include",

    "../libs/physx/physx/include",
    "../libs/steam-audio/include",
    "../libs/assimp/include",
    "../libs/glad/include",
    "../libs/glfw/include",
   -- "../libs/tinygltf",
    "../libs/glew/include",
    "../libs/glm",
    "../libs/ImGui",

  }

  libdirs {
    "../libs/steam-audio/lib/windows-x64",
    "../libs/lua",
    "../libs/spdlog/build/Release",
    "../libs/assimp/lib/Debug",
    "../libs/glfw/build/src/Debug",
    "../libs/ImGui"
  }

  files {
    "../libs/ImGui/*.cpp",
    "../libs/ImGui/backends/imgui_impl_glfw.cpp",
    "../libs/ImGui/backends/imgui_impl_Opengl3.cpp",
    "../libs/glad/src/glad.c",

    "./*.cpp",
    "./*.h",
    "./**/*.cpp",
    "./**/*.h"
  }


  filter { "system:windows"}
    prebuildcommands {
      -- Copy shaders 
      "copy graphics\\shaders\\fragment.shader            ..\\build\\SandboxApplication\\Debug\\test.fs", 
      "copy graphics\\shaders\\vertex.shader              ..\\build\\SandboxApplication\\Debug\\test.vs",
      "copy graphics\\shaders\\RenderSurfaceFrag.shader   ..\\build\\SandboxApplication\\Debug\\RenderSurface.fs",
      "copy graphics\\shaders\\RenderSurfaceVert.shader   ..\\build\\SandboxApplication\\Debug\\RenderSurface.vs" 
    }
    
    links {
      -- This needs to fall under the filter as the names can differ on different platforms 
      "phonon",
      "lua54",
      "spdlog",
      "assimp-vc143-mtd",
      "glfw3"
    }

  filter { "system:linux" }
    prebuildcommands {
      -- Copy shaders
      "cp graphics/shaders/fragment.shader ../build/SandboxApplication/Debug/test.fs", 
      "cp graphics/shaders/vertex.shader ../build/SandboxApplication/Debug/test.vs",
      "cp graphics/shaders/RenderSurfaceFrag.shader ../build/SandboxApplication/Debug/RenderSurface.fs",
      "cp graphics/shaders/RenderSurfaceVert.shader ../build/SandboxApplication/Debug/RenderSurface.vs" 
    }
